# include <stdio.h>
# include <bench.h>
# include <proc.io>
# include "iodef.h"
# include "field.h"
# include "sup.h"
# include "screen.h"


int no_msg = TRUE;
/*
* get the first element in the current table
*/

int start_field(table, ip)
int table;
struct ipf *ip;
{
	int i;

	ichar = K_CR;

	for (i = 0; ip[i].screen != -1; i++)
		if (ip[i].table == table)
			return(i);
	return(RET);
}

/*
* get the last element in the current table
*/

int end_field(table, ip)
int table;
struct ipf *ip;
{
	int i;
	for (i = 0; ip[i].screen != -1; i++)
		;
	i--;
	for (; i > 0; i--)
		if (ip[i].table == table)
			return(i);
	return(RET);
}


/*
* find the next field in the current table
*/

void next_field(cur, table, ip)
int *cur;
int table;
struct ipf *ip;
{
	int i;
	for (i = *cur + 1; ip[i].screen != -1; i++)
	{
		if (ip[i].table == table)
		{
			*cur = i;
			return;
		}
	}
	*cur = RET;
}

/*
* find the previous field in the current table
*/

void prev_field(cur, table, ip)
int *cur, table;
struct ipf *ip;
{
	int i;
	for (i = *cur - 1; i > 0; i--)
	{
		if (ip[i].table == table)
		{
			*cur = i;
			return;
		}
	}
	*cur = end_field(table, ip);
}

/*
* make sure the current field is valid.
* especially usefull for conditional gotos 
* that jump past the bounds of the current screen
*/

void valid_field(cur, table, ip)
int *cur, table;
struct ipf *ip;
{
	int i;
	for (i = 0; ip[i].screen != -1; i++)
		if (ip[i].table == table)
			if (i == *cur)
				return;
	*cur = RET;
}

/*
* Search through ip structure for the current element
* using field index
*/
int get_ipidx(j, table, ip)
int j, table;
struct ipf *ip;
{
	int i;
	for (i = 0; ip[i].screen != -1; i++)
		if (ip[i].table == table)
			if (ip[i].t_num == j)
				return(i);
	return(0);
}
